﻿// 定义编辑窗口引用
var editPane = null;
var prg_count = 0;
var prg_interval_hnd;
var bytesPerPiece = 1024 * 1024 * 2; // 每个文件切片大小定为2MB .
var totalPieces;
var fileNameArr = new Array();
var checkupload_interval;
var old_text = '';
var draftsave_interval = null;
var curr_bold = null;
var curr_italic = null;
var curr_underline = null;
var curr_strikethrough = null;
var curr_color = null;
var curr_hiliteColor = null;
var curr_justifyLeft = null;
var curr_justifyCenter = null;
var curr_justifyRight = null;
var curr_fontName = null;
var curr_fontSize = null;
var paintBegin = false;
var startCursor = null;
var endCursor = null;
var curr_Cursor_X = 0;
var startCursor_X = null;
var endCursor_X = null;
var lastEndCursor = null;
var selectBegin = false;

//初始化编辑窗口
(function () {
    $(".toolbar span").click(function (event) {
        event.stopPropagation();
        console.log("The span element was clicked.");
    });

    editPane = document.getElementById("editor").contentWindow;
    var browser = myBrowser();
    if (browser == 'FF') {
        console.log("火狐浏览器.");
        makeEditable();
    } else {
        //打开编辑模式
        editPane.document.designMode = 'on';
        editPane.document.contentEditable = true;
        editPane.document.open();
        editPane.document.write('');
        editPane.document.close();
    }
    
    editPane.focus();//获取焦点
    savelastEditRange();
    if (editPane.document.attachEvent) {
        editPane.document.attachEvent('onkeypress', showcharcount);
        editPane.attachEvent('onkeydown', tab_increase_indent); /* damn IE hack */
    }
    else {
        editPane.document.addEventListener('keyup', showcharcount, false);
        editPane.document.addEventListener('keydown', tab_increase_indent, false);
    }

    // 编辑框点击事件
    editPane.onclick = function (e) {
        //console.log(e);
        if (selectBegin) {
            endCursor = pickCursor();
            endCursor_X = getCursortPosition(editPane);
            selectRange();
            $('.Select').removeClass("sel-li");
            selectBegin = false;
            return;
        }

        if (paintBegin) {
            return;//格式刷期间，不再获取当前格式
        }
        curr_bold = editPane.document.queryCommandValue("Bold");
        curr_italic = editPane.document.queryCommandValue("italic");
        curr_underline = editPane.document.queryCommandValue("underline");
        curr_strikethrough = editPane.document.queryCommandValue("strikethrough");
        curr_color = editPane.document.queryCommandValue("ForeColor");
        curr_hiliteColor = editPane.document.queryCommandValue("backcolor");
        curr_justifyLeft = editPane.document.queryCommandValue("justifyLeft");
        curr_justifyCenter = editPane.document.queryCommandValue("justifyCenter");
        curr_justifyRight = editPane.document.queryCommandValue("justifyRight");
        curr_fontName = editPane.document.queryCommandValue("FontName");
        curr_fontSize = editPane.document.queryCommandValue("FontSize");
        $('#color').find('.box-item').removeClass('sel-box-item');
        $('#bkcolor').find('.box-item').removeClass('sel-box-item');
        $('.c-' + rgb2hex(curr_color)).addClass('sel-box-item');
        $('.b-' + rgb2hex(curr_hiliteColor)).addClass('sel-box-item');
        if (curr_bold == 'true') {
            $('.Bold').addClass("sel-li");
        } else {
            $('.Bold').removeClass("sel-li");
        }

        if (curr_italic=='true') {
            $('.italic').addClass("sel-li");
        } else {
            $('.italic').removeClass("sel-li");
        }

        if (curr_underline == 'true') {
            $('.underline').addClass("sel-li");
        } else {
            $('.underline').removeClass("sel-li");
        }

        if (curr_strikethrough == 'true') {
            $('.strikethrough').addClass("sel-li");
        } else {
            $('.strikethrough').removeClass("sel-li");
        }

        if (curr_justifyLeft == 'true') {
            $('.justifyLeft').addClass("sel-li");
        } else {
            $('.justifyLeft').removeClass("sel-li");
        }

        if (curr_justifyCenter == 'true') {
            $('.justifyCenter').addClass("sel-li");
        } else {
            $('.justifyCenter').removeClass("sel-li");
        }

        if (curr_justifyRight == 'true') {
            $('.justifyRight').addClass("sel-li");
        } else {
            $('.justifyRight').removeClass("sel-li");
        }

        var isfind = false;
        $("#divfamilyselect ul li a").each(function (index, item) {
            var value = $(item).attr("selectid");
            if (value == curr_fontName) {
                $("#divfamilyselect cite").html($(item).text());
                isfind = true;
                return false;
            }
        });

        if (isfind) {
            $("#hiddenfamily").val(curr_fontName);
        } else {
            $("#hiddenfamily").val('宋体');
            $("#hiddenfamily").change();
        }
        
        $("#divsizeselect ul li a").each(function (index, item) {
            if ((index + 1) == curr_fontSize) {
                $("#divsizeselect cite").html($(item).text());
                return false;
            }
        });

        $("#hiddensize").val(curr_fontSize);
        savelastEditRange();
    }

    //编辑框按键弹起事件
    editPane.onmouseup = function (e) {
        if (!paintBegin) {
            return;
        }

        //formatPaint();
    }

    editPane.onblur = function (e) {

    }

    var is_enable_draft = $("#hidden_enable_draft").val();
    if (is_enable_draft == "1") {
        old_text = '';
        draftsave_interval = setInterval(draftsave, "5000");
    }
})();

function tab_increase_indent(e) {
    var TABKEY = 9;
    if (e.keyCode == TABKEY) {
        if (e.preventDefault) {
            e.preventDefault();
        }
        if (e.shiftKey) {
            Outdent();
        }
        else {
            Indent();
        }
        
        return false;
    }
}

function Indent() {
    editPane.document.execCommand('Indent', 'false', null);
}

function Outdent() {
    editPane.document.execCommand('Outdent', 'false', null);
}

function formatPaint() {
    editPane.document.execCommand('removeFormat', false, null);
    if (curr_bold != null && curr_bold == 'true') {
        editPane.document.execCommand('Bold', false, null);
    }

    if (curr_italic != null && curr_italic == 'true') {
        editPane.document.execCommand('italic', false, null);
    }

    if (curr_underline != null && curr_underline == 'true') {
        editPane.document.execCommand('underline', false, null);
    }

    if (curr_strikethrough != null && curr_strikethrough == 'true') {
        editPane.document.execCommand('strikethrough', false, null);
    }

    if (curr_color != null) {
        editPane.document.execCommand('foreColor', false, curr_color);
    }

    if (curr_hiliteColor != null) {
        editPane.document.execCommand('hiliteColor', false, curr_hiliteColor);
    }

    if (curr_justifyLeft != null && curr_justifyLeft == 'true') {
        editPane.document.execCommand('justifyLeft', false, null);
    }

    if (curr_justifyCenter != null && curr_justifyCenter == 'true') {
        editPane.document.execCommand('justifyCenter', false, null);
    }

    if (curr_justifyRight != null && curr_justifyRight == 'true') {
        editPane.document.execCommand('justifyRight', false, null);
    }

    if (curr_fontName != null) {
        editPane.document.execCommand('FontName', false, curr_fontName);
    }

    if (curr_fontSize != null) {
        editPane.document.execCommand('fontSize', false, curr_fontSize);
    }

    $('.Painter').removeClass("sel-li");
    paintBegin = false;
}

function makeEditable() {
    //必须放到onload里，不然会设置无效
    document.getElementById('editor').onload = function () {
        try {
            // 通过designMode全局启用编辑
            document.getElementById('editor').contentDocument.designMode = 'on';
            // 或针对特定元素设置contentEditable
            document.getElementById('editor').contentDocument.body.contentEditable = true;
        } catch (e) {
            console.error('跨域访问被阻止，需配置同源策略或postMessage');
        }
    }

    //editPane.document.body.contentEditable = 'true';

    ////in moz you cannot change desgin mode straight away so try and then retry  
    //try {
    //    editPane.document.designMode = "on";
    //} catch (e) {
    //    setTimeout(makeEditable, 250);
    //    return false;
    //}

    //return true;
}

function savelastEditRange() {
    try {
        var selection = editPane.document.getSelection();
        if (selection.getRangeAt) {
            try {
                lastEditRange = selection.getRangeAt(0);
                //console.log(lastEditRange);
            } catch (e) {
            }
        }
    } catch (e) {
    }
}

// 获取当前光标位置
getCursortPosition = function (element) {
    var caretOffset = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    // 谷歌、火狐
    if (typeof win.getSelection != "undefined") {
        sel = win.getSelection();
        // 选中的区域
        if (sel.rangeCount > 0) {
            var range = win.getSelection().getRangeAt(0);
            // 克隆一个选中区域
            var preCaretRange = range.cloneRange();
            // 设置选中区域的节点内容为当前节点
            preCaretRange.selectNodeContents(element.document);
            // 重置选中区域的结束位置
            preCaretRange.setEnd(range.endContainer, range.endOffset);
            caretOffset = preCaretRange.toString().length;
        }
        // IE浏览器
    } else if ((sel = doc.selection) && sel.type != "Control") {
        var textRange = sel.createRange();
        var preCaretTextRange = doc.body.createTextRange();
        preCaretTextRange.moveToElementText(element);
        preCaretTextRange.setEndPoint("EndToEnd", textRange);
        caretOffset = preCaretTextRange.text.length;
    }
    return caretOffset;
}

function pickCursor() {
    try {
        var selection = editPane.document.getSelection();
        console.log(selection);
        if (selection.getRangeAt) {
            return selection.getRangeAt(0);
        }
    } catch (e) {
    }
}

function selectRange() {
    try {
        var selection = editPane.document.getSelection();
        selection.removeAllRanges();
        var range = editPane.document.createRange();
        var startNode = startCursor.startContainer;
        var startOffset = startCursor.startOffset;
        console.log("startNode：");
        console.log(startNode);
        console.log("startOffset：");
        console.log(startOffset);
        var endNode = endCursor.startContainer;
        var endOffset = endCursor.startOffset;
        console.log("endNode：");
        console.log(endNode);
        console.log("endOffset：");
        console.log(endOffset);
        if (startCursor_X < endCursor_X) {
            range.setStart(startNode, startOffset);
            range.setEnd(endNode, endOffset);
        } else {
            range.setStart(endNode, endOffset);
            range.setEnd(startNode, startOffset);
        }

        selection.addRange(range);
    } catch (e) {
    }
}

function refocus() {
    editPane.focus();
    try {
        var selection = editPane.document.getSelection();
        var currEditRange = selection.getRangeAt(0);
        if (currEditRange != lastEditRange) {
            lastEditRange = currEditRange;
        }
        if (lastEditRange) {
            selection.removeAllRanges();
            selection.addRange(lastEditRange);
        } else {
        }
        
    } catch (e) {
    }
}

function onSelect() {
    refocus();
    if ($('.Select').hasClass('sel-li')) {
        $('.Select').removeClass("sel-li");
        selectBegin = false;
    } else {
        startCursor = pickCursor();
        console.log("选取的开始光标：");
        console.log(startCursor);
        startCursor_X = getCursortPosition(editPane);
        $('.Select').addClass("sel-li");
        selectBegin = true;
    }
}

function onPaint() {
    refocus();
    if ($('.Painter').hasClass('sel-li')) {
        $('.Painter').removeClass("sel-li");
        $('.Painter span').removeClass("gss2");
        $('.Painter span').addClass("gss");
        formatPaint();
        paintBegin = false;
    } else {
        $('.Painter').addClass("sel-li");
        $('.Painter span').removeClass("gss");
        $('.Painter span').addClass("gss2");
        paintBegin = true;
    }
}

function onFullScreen() {
    var is_before_full = $('#editorcontainer .tool-container .FullScreen span').hasClass("qp");
    $('.topBg').toggleClass("hidden");
    $('.subNavBox').toggleClass("hidden");
    $('.bread-nav').toggleClass("hidden");
    $('.right-content .opbtn-container input').toggleClass("hidden");
    $('.right-content .form').toggleClass("hidden");
    $('.right-content .rj-form').toggleClass("hidden");
    $('.right-content .to-more').toggleClass("hidden");
    $('.right-content #toogleA').toggleClass("hidden");
    if (document.body.clientWidth < 650) {
        $('.opbtn-container').toggleClass('height26');
        if (is_before_full) {
            //标准高度：calc(100% - 96px) 96分为顶部高度和一个编辑器工具行高度
            //68为顶部高度 25为两行编辑器工具行高度
            //$('#editorcontainer').height($('#editorcontainer').height() + 68 - 25);
            //全屏简约模式
            $('#editorcontainer').css('height', 'calc(100% - 56px)');
        } else {
            //$('#editorcontainer').height($('#editorcontainer').height() - 68 + 25);
            //非全屏简约模式
            $('#editorcontainer').css('height', 'calc(100% - 98px)');
        }
        $('.to-more .more').toggleClass("hidden");
        $('.to-more .more-btn').toggleClass("hidden");
    } else {
        $('#editorcontainer').toggleClass("editor-container").toggleClass("editor-fullscreen-container");
    }
    $('#editorcontainer .tool-container .FullScreen span').toggleClass('qp').toggleClass('qxqp');
    $('#editorcontainer .tool-container .FullScreen span').prop('title', is_before_full ? "取消全屏" : "全屏");
    showMore(true);
}

function showMore(only_show_default = false) {
    //全屏+简约 calc(100% - 56px)
    //全屏+标准 calc(100% - 98px - 24px)
    //非全屏+简约 calc(100% - 96px)
    //非全屏+标准 calc(100% - 68px - 98px)
    if (document.body.clientWidth < 650) {
        var is_full = !$('#editorcontainer .tool-container .FullScreen span').hasClass("qp");
        if (only_show_default) {
            if (!$('#editorcontainer').hasClass("mobile-simple-editor")) {
                $('#editorcontainer').addClass("mobile-simple-editor");
            }
            if (!$('#editorcontainer .tool-container').hasClass("mobile-simple-tool-container")) {
                $('#editorcontainer .tool-container').addClass("mobile-simple-tool-container");
                //74为编辑器三行工具行高度
                //$('#editorcontainer').height($('#editorcontainer').height() + 74);
            }

            if (is_full) {
                //全屏简约模式
                $('#editorcontainer').css('height', 'calc(100% - 56px)');
            } else {
                //非全屏简约模式
                $('#editorcontainer').css('height', 'calc(100% - 98px)');
            }
        } else {
            $('#editorcontainer .tool-container').toggleClass("mobile-simple-tool-container");
            $('#editorcontainer').toggleClass("mobile-simple-editor");//只是空样式，方便切换
            if ($('#editorcontainer').hasClass("mobile-simple-editor")) {
                //$('#editorcontainer').height($('#editorcontainer').height() + 74);
                if (is_full) {
                    //全屏简约模式
                    $('#editorcontainer').css('height', 'calc(100% - 56px)');
                } else {
                    //非全屏简约模式
                    $('#editorcontainer').css('height', 'calc(100% - 98px)');
                }
            } else {
                //$('#editorcontainer').height($('#editorcontainer').height() - 74);
                if (is_full) {
                    //全屏标准模式
                    $('#editorcontainer').css('height', 'calc(100% - 124px)');
                } else {
                    //非全屏标准模式
                    $('#editorcontainer').css('height', 'calc(100% - 166px)');
                }
            }
        }
    } else {
        $('#editorcontainer .tool-container').toggleClass("mobile-simple-tool-container");
        $('#editorcontainer').toggleClass("mobile-simple-editor");//只是空样式，方便切换
    }
    $('#editorcontainer .toolbar li').each(function (index, item) {
        if (!$(item).hasClass('default') && !$(item).hasClass('charcount')) {
            if (!only_show_default) {
                $(item).toggleClass('hidden');
            } else {
                if (!$(item).hasClass('hidden')) {
                    $(item).addClass('hidden');
                }
            }
        }
    });
}

//改变效果
function onEffect(effect) {//基本通用函数
    refocus();
    var color = "red";
    editPane.document.execCommand(effect, false, color);
    if ($('.' + effect).hasClass('dq')) {
        $('.dq').removeClass("sel-li");
    }
    $('.' + effect).toggleClass("sel-li");
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

function onEffect2(effect) {
    refocus();
    editPane.document.execCommand(effect, false, null);
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//背景色函数
function back(effect) {
    refocus();
    var color = "#66ff99";
    editPane.document.execCommand(effect, false, color);
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//字体选择
function family(f) {
    refocus();
    var fm = f.value;
    var effect = "FontName";
    editPane.document.execCommand(effect, false, fm);
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
} 

//字体大小选择
function sized(f) {
    refocus();
    var fm = f.value;
    var effect = "fontSize";
    editPane.document.execCommand(effect, false, fm);
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
} 

//插入图片
function insertFace(img) {
    var image = "<img src='" + img.src + "'/>";
    editPane.focus();
    editPane.document.execCommand('insertImage', false, img.src);
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//打开表情窗口
function showFaces() {
    refocus();
    var li = $('.faces')[0];
    var face = document.getElementById("face");
    face.style.display = "block";
    face.style.top = (li.offsetTop+32) + 'px';
    if (document.body.clientWidth > 650) {
        face.style.left = li.offsetLeft + 'px';
    }
    
    face.onmouseover = function () {
        face.style.display = "block";
    }
    face.onmouseout = function () {
        face.style.display = "none";
    }
    face.onclick = function () {
        face.style.display = "none";
    }
    editPane.document.onclick = function () {
        face.style.display = "none";
    }
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//颜色框弹出
function showColors() {
    refocus();
    var li = $('.colors')[0];
    var color = document.getElementById("color");
    color.style.display = "block";
    color.style.top = (li.offsetTop + 32) + 'px';
    color.style.left = li.offsetLeft + 'px';

    color.onmouseover = function () {
        this.style.display = "block";
    }

    color.onmouseout = function () {
        this.style.display = "none";
    }

    color.onclick = function () {
        color.style.display = "none";
    }

    editPane.document.onclick = function () {
        color.style.display = "none";
    }
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//选色函数
function choose_color(k, img) {
    refocus();
    var color = k;
    var effect = "foreColor";
    editPane.document.execCommand(effect, false, color);
    $('#color').find('.box-item').removeClass('sel-box-item');
    $(img).parent().parent().addClass('sel-box-item');
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//背景颜色框弹出
function showbkColors() {
    refocus();
    var li = $('.bkcolors')[0];
    var bkcolor = document.getElementById("bkcolor");
    bkcolor.style.display = "block";
    bkcolor.style.top = (li.offsetTop + 32) + 'px';
    bkcolor.style.left = li.offsetLeft + 'px';

    bkcolor.onmouseover = function () {
        this.style.display = "block";
    }

    bkcolor.onmouseout = function () {
        this.style.display = "none";
    }

    bkcolor.onclick = function () {
        bkcolor.style.display = "none";
    }

    editPane.document.onclick = function () {
        bkcolor.style.display = "none";
    }
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//选背景色函数
function choose_bkcolor(k, img) {
    refocus();
    var color = k;
    var effect = "hiliteColor";
    editPane.document.execCommand(effect, false, color);
    $('#bkcolor').find('.box-item').removeClass('sel-box-item');
    $(img).parent().parent().addClass('sel-box-item');
    if (paintBegin) {
        $('.Painter').removeClass("sel-li");
        paintBegin = false;
    }
}

//上传
function upload(type) {
    var para = document.getElementById('forms');
    var inputObj = document.getElementById('myFile');
    if (type == 0) {
        inputObj.accept = "image/gif,image/jpg,image/jpeg,image/bmp,image/png";
    } else {
        inputObj.accept = "";
    }
    inputObj.click();
    inputObj.onchange = function () {
        startprg();
        uploadforajx();
    }

    refocus();
}

//异步上传
function uploadforajx() {
    var blob = document.getElementById("myFile").files[0];
    var filesize = blob.size;
    totalPieces = Math.ceil(filesize / bytesPerPiece);
    if (totalPieces <= 1) {
        smallupload();
    } else {
        bigupload();
    }
}

//小文件上传
function smallupload() {
    var formData = new FormData($('#forms')[0]);
    formData.append("myFile", $("#myFile")[0].files[0]);
    formData.append("issmall", 1);
    formData.append("affixguid", $('#hiddenAffixGuid').val());
    formData.append("affixbizid", bizid);

    $.ajax({
        url: upload_url,
        type: 'POST',
        cache: false,
        data: formData,
        processData: false,
        contentType: false,
        success: function (result) {
            console.log(result);
            closeInterval();
            var rspjson = eval('(' + result + ')');
            insertfile(rspjson.currname, rspjson.origname, rspjson.url, rspjson.width, rspjson.isimg, rspjson.ext, rspjson.id);
        }
    });
}

var blob;//文件对象
var filesize;//文件尺寸
var filename;//文件名称
//大文件上传
function bigupload() {
    blob = document.getElementById("myFile").files[0];
    filesize = blob.size;
    filename = blob.name;
    totalPieces = Math.ceil(filesize / bytesPerPiece);
    fileNameArr = [];
    startUpload(0);
}

function startUpload(index) {
    var start = bytesPerPiece * index;
    var end = start + bytesPerPiece;
    if (end > filesize) {
        end = filesize;
    }
    var chunk = blob.slice(start, end);
    var formData = new FormData();
    formData.append("myFile", chunk, index + '_' + filename);
    formData.append("totalPieces", totalPieces);
    formData.append("pieceindex", index);
    $.ajax({
        url: upload_url,
        type: 'POST',
        cache: false,
        data: formData,
        processData: false,
        contentType: false,
    }).done(function (res) {
        console.log(res);
        var rspjson = eval('(' + res + ')');
        console.log(rspjson.url);
        fileNameArr.push(rspjson.url);
        index++;
        var per = GetPercent(index, totalPieces);
        $('.prg .prgVAL').html(per);
        if (index < totalPieces) {
            startUpload(index);
        } else {
            bigUploadOK();
        }
    }).fail(function (res) {
        showerr("上传出错！"+res, 2000);
    });
}

///计算两个整数的百分比值 
function GetPercent(num, total) {
    num = parseFloat(num);
    total = parseFloat(total);
    if (isNaN(num) || isNaN(total)) {
        return "-";
    }
    return total <= 0 ? "0%" : (Math.round(num / total * 100) + "%");
}

function bigUploadOK() {
    console.log('upload ok!totalPieces=' + totalPieces);
    var fileNames = '';
    for (var i = 0; i < fileNameArr.length; i++) {
        var fname = fileNameArr[i];
        if (fileNames != '') {
            fname = '|' + fname;
        }

        fileNames += fname;
    }

    $.ajax({
        url: upload_ok_url,
        type: 'POST',
        cache: false,
        async: "false",
        dataType: "JSON",
        data: { fnames: fileNames, fullname: filename, affixguid: $('#hiddenAffixGuid').val(), affixbizid: bizid }
    }).done(function (res) {
        console.log(res);
        closeInterval();
        insertfile(res.currname, res.origname, res.url, res.width, res.isimg, res.ext,res.id);
    }).fail(function (res) {

    });
}

//插入文件
function insertfile(currname,origname,url,width,isimg,ext,id) {
    editPane.focus();
    var html = "";
    if (isimg == 0) {
        var ss = 'file';
        if (ext == ".doc" || ext == ".docx") {
            ss = 'docx';
        } else if (ext == ".xls" || ext == ".xlsx") {
            ss = 'xlsx';
        } else if (ext == ".pdf") {
            ss = 'pdf';
        } else if (ext == ".txt") {
            ss = 'txt';
        }

        html = "<img src='/js/editor/styles/img/" + ss + ".png'/>";
        html += "<a class='fyy-upload-file upload-" + ext.replace(".","") + " common-a' fileid='" + id + "' currname='" + currname + "' url='" + url + "' href='/download.html?id=" + id + "'>" + origname + "</a>";
    } else {
        console.log("插入图片:" + "***" + url);
        html = "<img class='fyy-upload-file pointer' currname='" + currname + "' style='width:" + width + "px' src='" + url + "' onclick=\"picshowPop('/affix/file/" + currname + "');var img='占位符'\">";
    }

    editPane.document.execCommand('insertHTML', false,  html);
}

//显示字符数
function showcharcount() {
    var frameContent = editPane.document.body.innerText;
    //alert("frame content : " + frameContent);
    $('.spanCharCount').html(frameContent.length);
}

function startprg() {
    prg_interval_hnd=setInterval("showprg()", 200);
}

function closeInterval() {
    clearInterval(prg_interval_hnd);
    var prg = document.getElementById('divprg');
    prg.style.display = 'none';
    $('.prg .prgVAL').html("");
}

function showprg() {
    var prg = document.getElementById('divprg');
    prg.style.display = 'block';
    if (prg_count == 6) {
        prg_count = 0;
        //prg.innerHTML = '';
        $('.prg .prgPOINT').remove();
    } else {
        var prg_p = document.createElement("div");
        prg_p.className = 'prg-p prgPOINT';
        prg_p.innerHTML = "<img src='" + mapurl + "js/editor/styles/img/点.png' />";
        prg.appendChild(prg_p);

        prg_count = prg_count + 1;
    }
}

function draftsave() {
    var storage = window.localStorage;
    if (!storage) {
        showerr("'你的浏览器不支持 localStorage 技术!无法使用草稿功能...'", 3000);
        return;
    }
    var content = $("#editor")[0].contentWindow.document.documentElement.outerHTML;
    if (old_text != content && content != '<html><head></head><body></body></html>') {
        old_text = content;
        var pagetype = $('#pagetype').val();
        var datetime = (new Date()).Format("yyyy-MM-dd hh:mm:ss");
        var datakey = pagetype + "#" + datetime;
        var nowtime = (new Date()).Format("hh:mm:ss");
        var data = {type: pagetype,time: datetime , text: content };
        var json = JSON.stringify(data);
        var draft_arr = [];
        for (var i = 0; i < storage.length; i++) {
            var key = storage.key(i);
            var data = storage[key];
            var obj = JSON.parse(data);
            if (key.split('#')[0] == pagetype) {
                if (obj.text == content) {
                    return;
                }
                draft_arr.push(obj);
            }
        }
        $('.draft').text(nowtime + "草稿");
        draft_arr.sort(compareAsc("time"));
        if (draft_arr.length == 7) {
            storage.removeItem(draft_arr[0].type + "#" + draft_arr[0].time);
        }

        storage.setItem(datakey, json);
    }
}

function showDraftBox() {
    var storage = window.localStorage;
    if (!storage) {
        showerr("'你的浏览器不支持 localStorage 技术!无法使用草稿功能...'", 3000);
        return;
    }
    $('.div-sel-history-popup .title').text("草稿箱");
    popuphistory.style.display = "block";
    shadehistory.style.display = "block";
    var draft_arr = [];
    var pagetype = $('#pagetype').val();
    for (var i = 0; i < storage.length; i++) {
        var key = storage.key(i);
        if (key.split('#')[0] == pagetype) {
            var data = storage[key];
            var obj = JSON.parse(data);
            draft_arr.push(obj);
        }
    }

    draft_arr.sort(compareDesc("time"));
    var rowcount = $('#tblhistory tr').length;
    for (var i = 0; i < rowcount - 1; i++) {
        $('#tblhistory tr:eq(1)').remove();
    }

    $.each(draft_arr, function (index, item) {
        var newtr = $('#tblhistory tr:eq(0)').clone();
        newtr.removeClass('hide');
        var time = item.time;
        var dateobj = new Date(item.time);
        var nowtime = new Date();
        if (nowtime.getDate() == dateobj.getDate() && nowtime.getDay() == dateobj.getDay()) {
            time = dateobj.Format("hh:mm:ss");
        } else {
            time = dateobj.Format("yyyy-MM-dd hh:mm:ss");
        }
        newtr.find("td").eq(0).html(time);
        var text = formatHtmltoText(item.text);
        newtr.find("td").eq(1).find('a').text(text.length > 15 ? (text.substr(0, 15) + "...") : text);
        newtr.find("td").eq(1).find('a').bind('click', { CONTENT: item.text }, function (event) {
            $('#editor').contents().find('body').html(event.data.CONTENT);
            hideHistoryPop();
        });
        newtr.show();
        newtr.mouseover(function () {
            $(this).addClass("over");
        }).mouseout(function () {
            $(this).removeClass("over");
        });
        $('#tblhistory').append(newtr);
    });
}

function exportdocx() {
    var url = '/handler.ashx?optype=exportdocx';
    var html = $("#editor")[0].contentWindow.document.documentElement.outerHTML;
    var data = { content: encodeURI(html) };
    exportdata(url, data);
}

function exportpdf() {
    var url = '/handler.ashx?optype=exportpdf';
    var html = $("#editor")[0].contentWindow.document.documentElement.outerHTML;
    var data = { content: encodeURI(html) };
    console.log(data);
    exportdata(url, data);
}

function compareDesc(propertyName) {
    return function (object1, object2) {
        var value1 = object1[propertyName];
        var value2 = object2[propertyName];
        if (value2 < value1) {
            return -1;
        } else if (value2 > value1) {
            return 1;
        } else {
            return 0;
        }
    }
}

function compareAsc(propertyName) {
    return function (object1, object2) {
        var value1 = object1[propertyName];
        var value2 = object2[propertyName];
        if (value2 < value1) {
            return 1;
        } else if (value2 > value1) {
            return -1;
        } else {
            return 0;
        }
    }
}

function rgb2hex(rgb) {
    try {
        rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
        function hex(x) {
            return ("0" + parseInt(x).toString(16)).slice(-2);
        }
        return hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);

    } catch (e) {
    }
}