﻿(function () {
    if (window.HashQuery) {
        return;
    }
    window.HashQuery = function () {
    };
    HashQuery.prototype = {
        HasHash: function () {
            if (location.hash === '' || location.hash.length == 0) {
                return false;
            }

            return true;
        },
        parseFromLocation: function () {
            if (location.hash === '' || location.hash.length == 0) {
                return;
            }

            var properties = location.hash.substr().trim('#','left').split('/');
            var index = 0;
            for (var p in this) {
                if (!this.hasOwnProperty(p) || typeof this[p] != 'string') {
                    continue;
                }
                if (index < properties.length) {
                    this[p] = properties[index];
                    if (this[p] === '-') {
                        this[p] = '';
                    }
                }

                index++;
            }
        },
        tohashurl: function () {
            var properties = [];
            for (var p in this) {
                var value = this[p];
                if (!this.hasOwnProperty(p)) {  // || typeof this[p] != 'string'
                    continue;
                }

                //alert(p + ' ' + value);
                properties.push(value);
            }

            return properties.join('/');
        },
        updateLocation: function () {
            //var properties = [];
            //for (var p in this) {
            //    var value = this[p];
            //    if (!this.hasOwnProperty(p) || typeof this[p] != 'string') {
            //        continue;
            //    }

            //    properties.push(value);
            //}

            var hashurl = this.tohashurl();
            if (!window.location.origin) {
                window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
            }

            var url = location.origin + location.pathname + location.search + "#" + hashurl;
            location.replace(url);
            if ($.browser.webkit == false) {
                window.location.hash = location.hash;
            } else {
                window.location.href = location.hash;
            }
        }
    };
})(); 

String.prototype.trim = function (char, type) {
    if (char) {
        if (type == 'left') {
            return this.replace(new RegExp('^\\' + char + '+', 'g'), '');
        } else if (type == 'right') {
            return this.replace(new RegExp('\\' + char + '+$', 'g'), '');
        }
        return this.replace(new RegExp('^\\' + char + '+|\\' + char + '+$', 'g'), '');
    }
    return this.replace(/^\s+|\s+$/g, '');
};

(function () {
    window.PortalHashQuery = function () {
        HashQuery.constructor.call(this);
        this.counttype = '';
        this.scrollto = '';
    };

    PortalHashQuery.constructor = PortalHashQuery;
    PortalHashQuery.prototype = new HashQuery();

    window.SearchGlobalHashQuery = function () {
        HashQuery.constructor.call(this);
        this.module = '';
        this.rendertype = '';
        this.pageindex = '';
        this.scrollto = '';
    };

    SearchGlobalHashQuery.constructor = SearchGlobalHashQuery;
    SearchGlobalHashQuery.prototype = new HashQuery();

    window.SearchDiaryHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.pageindex = '';
        this.keyword = '';
        this.memname = '';
        this.memid = '';
        this.fw = '';
        this.sort = '';
        this.sorttype = '';
        this.scrollto = '';
    };

    SearchDiaryHashQuery.constructor = SearchDiaryHashQuery;
    SearchDiaryHashQuery.prototype = new HashQuery();

    window.SearchCldDiaryHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
    };

    SearchCldDiaryHashQuery.constructor = SearchCldDiaryHashQuery;
    SearchCldDiaryHashQuery.prototype = new HashQuery();

    window.SearchPlanHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.day = '';
        this.pageindex = '';
        this.xiangxian = '';
        this.keyword = '';
        this.jhfl = '';
        this.status = '';
        this.sort = '';
        this.sorttype = '';
        this.memname = '';
        this.memid = '';
        this.scrollto = '';
    };

    SearchPlanHashQuery.constructor = SearchPlanHashQuery;
    SearchPlanHashQuery.prototype = new HashQuery();

    window.SearchCldPlanHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
    };

    SearchCldPlanHashQuery.constructor = SearchCldPlanHashQuery;
    SearchCldPlanHashQuery.prototype = new HashQuery();

    window.SearchEventHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.day = '';
        this.pageindex = '';
        this.keyword = '';
        this.sjdl = '';
        this.sjdlid = '';
        this.sjxl = '';
        this.memname = '';
        this.memid = '';
        this.fw = '';
        this.glryname = '';
        this.glryid = '';
        this.sort = '';
        this.sorttype = '';
        this.scrollto = '';
    };

    SearchEventHashQuery.constructor = SearchEventHashQuery;
    SearchEventHashQuery.prototype = new HashQuery();

    window.SearchCldEventHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.cldtype = '';
    };

    SearchCldEventHashQuery.constructor = SearchCldEventHashQuery;
    SearchCldEventHashQuery.prototype = new HashQuery();

    window.SearchAccountHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.day = '';
        this.pageindex = '';
        this.keyword = '';
        this.jzdl = '';
        this.jzdlid = '';
        this.jzxl = '';
        this.book = '';
        this.memname = '';
        this.memid = '';
        this.fw = '';
        this.glryname = '';
        this.glryid = '';
        this.sort = '';
        this.sorttype = '';
        this.scrollto = '';
    };

    SearchAccountHashQuery.constructor = SearchAccountHashQuery;
    SearchAccountHashQuery.prototype = new HashQuery();

    window.AccountReportHashQuery = function () {
        HashQuery.constructor.call(this);
        this.tjlx = '';
        this.startyear = '';
        this.endyear = '';
    };

    AccountReportHashQuery.constructor = AccountReportHashQuery;
    AccountReportHashQuery.prototype = new HashQuery();

    window.SearchPersonHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.ryfl = '';
        this.pageindex = '';
        this.keyword = '';
        this.sort = '';
        this.sorttype = '';
        this.scrollto = '';
        this.openids = '';
    };

    SearchPersonHashQuery.constructor = SearchPersonHashQuery;
    SearchPersonHashQuery.prototype = new HashQuery();

    window.SearchLogHashQuery = function () {
        HashQuery.constructor.call(this);
        this.module = '';
        this.pageindex = '';
        this.keyword = '';
        this.date = '';
    };

    SearchLogHashQuery.constructor = SearchLogHashQuery;
    SearchLogHashQuery.prototype = new HashQuery();

    window.SearchDocHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.pageindex = '';
        this.keyword = '';
        this.doctypename = '';
        this.doctype = '';
        this.memname = '';
        this.memid = '';
        this.fw = '';
        this.sort = '';
        this.sorttype = '';
        this.scrollto = '';
        this.openids = '';
    };

    SearchDocHashQuery.constructor = SearchDocHashQuery;
    SearchDocHashQuery.prototype = new HashQuery();

    window.SearchDicHashQuery = function () {
        HashQuery.constructor.call(this);
        this.openids = '';
    };

    SearchDicHashQuery.constructor = SearchDicHashQuery;
    SearchDicHashQuery.prototype = new HashQuery();

    window.SearchAffixHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.fjlx = '';
        this.pageindex = '';
        this.keyword = '';
        this.sort = '';
        this.sorttype = '';
    };

    SearchAffixHashQuery.constructor = SearchAffixHashQuery;
    SearchAffixHashQuery.prototype = new HashQuery();

    window.SearchMessageHashQuery = function () {
        HashQuery.constructor.call(this);
        this.year = '';
        this.month = '';
        this.pageindex = '';
        this.keyword = '';
    };

    SearchMessageHashQuery.constructor = SearchMessageHashQuery;
    SearchMessageHashQuery.prototype = new HashQuery();
})(); 